<?php

require 'flight/Flight.php';
require 'model/model.php';

Todo::init();

Flight::route('GET /todo(/@id)','getTodos');
Flight::route('POST /todo','addTodo');
Flight::route('DELETE /todo/@id','deleteTodo');
Flight::route('PUT /todo/@id','updateTodo');

function addTodo()
{
	$todo = [
		"title" => Flight::request()->data->title , 
		"done" => Flight::request()->data->done   
	];	

	$id = Todo::create($todo);
	Flight::response()->header("Location",Flight::request()->url."/".$id);
	$todo['id'] = $id;
	Flight::json($todo,201);

}

function deleteTodo($id)
{
	// TODO
}

function updateTodo($id)
{
	// TODO
}


function getTodos($id = null)
{
	$filter = Flight::request()->query->filter ?? "all";

	if ($id === null){
		switch($filter){
		case "done":
			$todos = Todo::findCompleted();
			break;
		case "active":
			$todos = Todo::findUnCompleted();
			break;
		default:
			$todos = Todo::findAll();
		}
		Flight::json(
			[
				"results" => $todos
			]			
		);

	} else {
		$todo = Todo::find($id);
		if ($todo)
			Flight::json($todo);
		else
			Flight::halt(404);
	}
}

Flight::start();
